#ifndef simpleSAN_H_
#define simpleSAN_H_

#include "external/ExampleLibrary/TestClass.h"
#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/GlobalVariables.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               simpleSAN Submodel Definition                   
*********************************************************************/

class simpleSAN:public SANModel{
public:

class Timed_Activity1Activity:public Activity {
public:

  Place* Place1;
  short* Place1_Mobius_Mark;
  Place* Place2;
  short* Place2_Mobius_Mark;

  double* TheDistributionParameters;
  Timed_Activity1Activity();
  ~Timed_Activity1Activity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Timed_Activity1ActivityActivity

  //List of user-specified place names
  Place* Place1;
  Place* Place2;

  // Create instances of all actvities
  Timed_Activity1Activity Timed_Activity1;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  simpleSAN();
  ~simpleSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end simpleSAN

#endif // simpleSAN_H_
